Package com.sas.metadata.remote

# Interface PSColumnLayoutComponent

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `PSLayoutComponent`, `Remote`, `Root`

public interface PSColumnLayoutComponent extends PSLayoutComponent
Provides the information needed to lay a PortalPage out in columns.

Attributes of PSColumnLayoutComponent are:

- `ColumnWidth`
- `NumberOfPortlets`

Associations of PSColumnLayoutComponent are:

## Usage

To create an instance of this PSColumnLayoutComponent, use the `factory` create methods.
Example: create a PSColumnLayoutComponent with name "PSColumnLayoutComponent_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     PSColumnLayoutComponent myObject = (PSColumnLayoutComponent) factory.createComplexMetadataObject(objectStore, "PSColumnLayoutComponent_Object", MetadataObjects.PSCOLUMNLAYOUTCOMPONENT, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ATTRIBUTE_COLUMNWIDTH_NAME`
  Constant used for the name of the ColumnWidth attribute.
  `static final String`
  `ATTRIBUTE_NUMBEROFPORTLETS_NAME`
  Constant used for the name of the NumberOfPortlets attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PSLayoutComponent

  `ASSOCIATION_OWNINGPAGE_NAME, ASSOCIATION_PORTLETS_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getColumnWidth()`
  Gets the `String` value of `ColumnWidth`
  `int`
  `getColumnWidthMaxLength()`
  Gets the maximum length of `ColumnWidth`
  `int`
  `getColumnWidthState()`
  Gets the Metadata State of `ColumnWidth`
  `int`
  `getNumberOfPortlets()`
  Gets the `int` value of `NumberOfPortlets`
  `int`
  `getNumberOfPortletsState()`
  Gets the Metadata State of `NumberOfPortlets`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setColumnWidth(String inColumnWidth)`
  Sets the `ColumnWidth` value and sets the state to MetadataState.LOCAL.
  `void`
  `setColumnWidth(String inColumnWidth, int state)`
  Sets the `ColumnWidth` Metadata State.
  `void`
  `setColumnWidthState(int state)`
  Sets the Metadata State of `ColumnWidth`.
  `void`
  `setNumberOfPortlets(int inNumberOfPortlets)`
  Sets the `NumberOfPortlets` value and sets the state to MetadataState.LOCAL.
  `void`
  `setNumberOfPortlets(int inNumberOfPortlets, int state)`
  Sets the `NumberOfPortlets` Metadata State.
  `void`
  `setNumberOfPortlets(String inNumberOfPortlets)`
  Sets the `NumberOfPortlets` value and sets the state to MetadataState.LOCAL.
  `void`
  `setNumberOfPortlets(String inNumberOfPortlets, int state)`
  Sets the `NumberOfPortlets` value and Metadata State.
  `void`
  `setNumberOfPortletsState(int state)`
  Sets the Metadata State of `NumberOfPortlets`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.PSLayoutComponent

  `getOwningPage, getOwningPages, getOwningPages, getPortlets, getPortlets, setOwningPage, setOwningPages, setOwningPages, setPortlets, setPortlets`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_COLUMNWIDTH_NAME

    static final String ATTRIBUTE_COLUMNWIDTH_NAME
    Constant used for the name of the ColumnWidth attribute.

    ColumnWidth: Designates the width of the screen area that the component should be rendered in.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_NUMBEROFPORTLETS_NAME

    static final String ATTRIBUTE_NUMBEROFPORTLETS_NAME
    Constant used for the name of the NumberOfPortlets attribute.

    NumberOfPortlets: Provides the number of Portlets associated to be displayed in the column. Should be the same as the number of Portlets associated with the ColumnLayoutComponent.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `PSLayoutComponent`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `PSLayoutComponent`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getColumnWidth

    String getColumnWidth() throws RemoteException
    Gets the `String` value of `ColumnWidth`
    Returns:
      The `ColumnWidth`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getColumnWidthState

    int getColumnWidthState() throws RemoteException
    Gets the Metadata State of `ColumnWidth`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getColumnWidthMaxLength

    int getColumnWidthMaxLength() throws RemoteException
    Gets the maximum length of `ColumnWidth`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNumberOfPortlets

    int getNumberOfPortlets() throws RemoteException
    Gets the `int` value of `NumberOfPortlets`
    Returns:
      The `NumberOfPortlets`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNumberOfPortletsState

    int getNumberOfPortletsState() throws RemoteException
    Gets the Metadata State of `NumberOfPortlets`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### setColumnWidth

    void setColumnWidth(String inColumnWidth) throws RemoteException
    Sets the `ColumnWidth` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inColumnWidth` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setColumnWidth

    void setColumnWidth(String inColumnWidth, int state) throws RemoteException
    Sets the `ColumnWidth` Metadata State.
    Parameters:
      `inColumnWidth` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setColumnWidthState

    void setColumnWidthState(int state) throws RemoteException
    Sets the Metadata State of `ColumnWidth`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNumberOfPortlets

    void setNumberOfPortlets(int inNumberOfPortlets) throws RemoteException
    Sets the `NumberOfPortlets` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inNumberOfPortlets` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNumberOfPortlets

    void setNumberOfPortlets(int inNumberOfPortlets, int state) throws RemoteException
    Sets the `NumberOfPortlets` Metadata State.
    Parameters:
      `inNumberOfPortlets` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNumberOfPortlets

    void setNumberOfPortlets(String inNumberOfPortlets) throws RemoteException
    Sets the `NumberOfPortlets` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inNumberOfPortlets` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNumberOfPortlets

    void setNumberOfPortlets(String inNumberOfPortlets, int state) throws RemoteException
    Sets the `NumberOfPortlets` value and Metadata State.
    Parameters:
      `inNumberOfPortlets` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNumberOfPortletsState

    void setNumberOfPortletsState(int state) throws RemoteException
    Sets the Metadata State of `NumberOfPortlets`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.